<template>
  <div v-if="editMode" :class="{ 'editable-field': true, 'alted': isAltPressed }">
    <!-- <pre>{{ config }}</pre> -->
    <!-- <div contenteditable="true" @input="update">{{ textfieldEditedData }}</div> -->
   <!-- {{ config }} -->
    <!-- {{ rawKey }} -->
    <!-- <pre>{{ textfieldRawData }}</pre> -->
    <!-- {{ typeof textfieldRawData }} -->
    <check-na :field="textfieldRawData"><inline-editor v-model="textfieldRawData" :br="inputWithBr" :read-only="config.read_only" :placeholder="textfieldPlaceholder"></inline-editor></check-na>
  </div>
  <div v-else-if="textfieldData">
    <div v-if="displayAsHTML" v-html="textfieldData"></div>
    <div v-else>
      {{ textfieldData }}
    </div>
  </div>
  <div v-else>
    <slot></slot>
  </div>
</template>

<script>
import _ from 'lodash'

import { mapActions, mapGetters } from 'vuex'

import InlineEditor from '@/components/Editable/Utils/InlineEditor'
import CheckNa from '@/components/Editable/Utils/CheckNa'

export default {
  components: {
    InlineEditor,
    CheckNa
  },

  props: {
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: true
    }
    // options: {
    //   type: Object,
    //   required: false
    // }
  },

  data () {
    return {
      // rawKey: this.displayAsHTML ? (this.inputWithBr ? 'inner-html-w-br' : 'inner-html') : 'inner-html'
    }
  },

  computed: {
    ...mapGetters({
      getEditedField: 'Y3TI/getEditedField',
      editMode: 'Y3TI/editMode',
      getFieldConfig: 'Y3TI/getFieldConfig',
      isAltPressed: 'Y3TI/isAltPressed'
    }),

    config () {
      return this.getFieldConfig({ node: this.node, path: this.path })
    },

    textfieldPlaceholder () {
      return _.get(this.config, 'widget.form.settings.placeholder')
    },

    displayAsHTML () {
      return _.get(this.config, 'options.display_as_html', false)
    },

    inputWithBr () {
      return _.get(this.config, 'options.input_with_br', false)
    },

    rawKey () {
      return this.displayAsHTML ? (this.inputWithBr ? 'inner-html-w-br' : 'inner-html') : 'inner-html'
    },

    textfieldData () {
      return _.get(this.node, this.path)
    },
    // textfieldEditedData () {
    //   return this.getEditedField({ node: this.node, path: this.path })
    // },

    textfieldRawData: {
      get () {
        // return _.get(this.$store.state.app.edited, this.editablePath)
        return this.getEditedField({ node: this.node, path: this.path, raw: this.rawKey })
      },
      set (value) {
        this.storeEditableFieldData({ data: { node: this.node, path: this.path, input: value, raw: this.rawKey } })
      }
    }
  },

  methods: {
    ...mapActions({
      storeEditableFieldData: 'Y3TI/storeEditableFieldData'
    })
    // update (e) {
    //   this.storeEditableFieldData({ data: { node: this.node, path: this.path, input: e.target.innerHTML, raw: this.rawKey } })
    // }
  }
}
</script>

<style lang="scss" scoped>
</style>
